Index: trunk/src/VBox/Runtime/common/math/ceill.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/ceill.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/ceill.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/cosl.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/cosl.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/cosl.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/fabs.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/fabs.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/fabs.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/fabsf.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/fabsf.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/fabsf.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/fabsl.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/fabsl.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/fabsl.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/floor.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/floor.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/floor.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/floorf.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/floorf.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/floorf.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/floorl.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/floorl.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/floorl.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/ldexpl.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/ldexpl.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/ldexpl.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/llrint.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/llrint.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/llrint.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/llrintf.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/llrintf.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/llrintf.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/llrintl.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/llrintl.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/llrintl.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/logl.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/logl.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/logl.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/lrint.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/lrint.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/lrint.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/lrintf.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/lrintf.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/lrintf.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/lrintl.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/lrintl.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/lrintl.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/remainder.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/remainder.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/remainder.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/remainderf.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/remainderf.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/remainderf.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/remainderl.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/remainderl.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/remainderl.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/sinl.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/sinl.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/sinl.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/tanl.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/tanl.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/tanl.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/trunc.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/trunc.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/trunc.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/truncf.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/truncf.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/truncf.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/math/truncl.asm
===================================================================
--- trunk/src/VBox/Runtime/common/math/truncl.asm	(revision 28800)
+++ trunk/src/VBox/Runtime/common/math/truncl.asm	(revision 44528)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2007 Oracle Corporation
+; Copyright (C) 2006-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as