Index: trunk/src/VBox/Runtime/common/asm/ASMCpuId_Idx_ECX.asm
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMCpuId_Idx_ECX.asm	(revision 44528)
+++ trunk/src/VBox/Runtime/common/asm/ASMCpuId_Idx_ECX.asm	(revision 44529)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2013 Oracle Corporation
+; Copyright (C) 2012-2013 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/asm/ASMNopPause.asm
===================================================================
--- trunk/src/VBox/Runtime/common/asm/ASMNopPause.asm	(revision 44528)
+++ trunk/src/VBox/Runtime/common/asm/ASMNopPause.asm	(revision 44529)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2010 Oracle Corporation
+; Copyright (C) 2009-2010 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/asm/asm-fake.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/asm/asm-fake.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/asm/asm-fake.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2010-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/checksum/adler32.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/checksum/adler32.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/checksum/adler32.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/checksum/crc32-zlib.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/checksum/crc32-zlib.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/checksum/crc32-zlib.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/checksum/ipv4.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/checksum/ipv4.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/checksum/ipv4.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2008-2011 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/checksum/manifest.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/checksum/manifest.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/checksum/manifest.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2009-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/checksum/manifest2.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/checksum/manifest2.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/checksum/manifest2.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2010-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/checksum/manifest3.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/checksum/manifest3.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/checksum/manifest3.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2010-2011 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/checksum/md5str.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/checksum/md5str.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/checksum/md5str.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/checksum/sha1.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/checksum/sha1.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/checksum/sha1.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/checksum/sha1str.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/checksum/sha1str.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/checksum/sha1str.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/checksum/sha256.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/checksum/sha256.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/checksum/sha256.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/checksum/sha256str.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/checksum/sha256str.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/checksum/sha256str.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/checksum/sha512.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/checksum/sha512.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/checksum/sha512.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/checksum/sha512str.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/checksum/sha512str.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/checksum/sha512str.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/dbg/dbg.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/dbg/dbg.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/dbg/dbg.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/dbg/dbgas.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/dbg/dbgas.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/dbg/dbgas.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2009-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/dbg/dbgmod.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/dbg/dbgmod.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/dbg/dbgmod.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2009-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/dbg/dbgmodcontainer.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/dbg/dbgmodcontainer.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/dbg/dbgmodcontainer.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2009-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/dbg/dbgmoddwarf.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/dbg/dbgmoddwarf.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/dbg/dbgmoddwarf.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2011-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/dbg/dbgmodnm.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/dbg/dbgmodnm.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/dbg/dbgmodnm.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2009-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/dvm/dvm.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/dvm/dvm.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/dvm/dvm.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2011-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/dvm/dvmbsdlabel.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/dvm/dvmbsdlabel.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/dvm/dvmbsdlabel.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2011-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/dvm/dvmgpt.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/dvm/dvmgpt.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/dvm/dvmgpt.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2011-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/dvm/dvmmbr.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/dvm/dvmmbr.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/dvm/dvmmbr.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2011-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/err/errinfo.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/err/errinfo.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/err/errinfo.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2010-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/RTAssertMsg1Weak.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/RTAssertMsg1Weak.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/RTAssertMsg1Weak.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2008-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/RTAssertMsg2.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/RTAssertMsg2.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/RTAssertMsg2.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2008-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/RTAssertMsg2AddWeakV.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/RTAssertMsg2AddWeakV.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/RTAssertMsg2AddWeakV.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/RTAssertMsg2WeakV.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/RTAssertMsg2WeakV.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/RTAssertMsg2WeakV.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/RTFileOpenF.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/RTFileOpenF.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/RTFileOpenF.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2010-2011 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/RTFileOpenV.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/RTFileOpenV.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/RTFileOpenV.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2010-2011 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/buildconfig.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/buildconfig.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/buildconfig.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/getoptargv.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/getoptargv.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/getoptargv.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2010-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/handletable.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/handletable.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/handletable.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2008-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/handletable.h
===================================================================
--- trunk/src/VBox/Runtime/common/misc/handletable.h	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/handletable.h	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2008-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/handletablectx.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/handletablectx.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/handletablectx.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2008-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/handletablesimple.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/handletablesimple.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/handletablesimple.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2008-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/message.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/message.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/message.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2009-2011 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/sanity-c.c
===================================================================
--- trunk/src/VBox/Runtime/common/misc/sanity-c.c	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/sanity-c.c	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2007-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/sanity-cpp.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/sanity-cpp.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/sanity-cpp.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2007-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/sanity.h
===================================================================
--- trunk/src/VBox/Runtime/common/misc/sanity.h	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/sanity.h	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2007-2011 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/sg.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/sg.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/sg.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2013 Oracle Corporation
+ * Copyright (C) 2010-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/misc/term.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/misc/term.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/misc/term.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2009-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathAppend.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathAppend.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/path/RTPathAppend.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathTraverseList.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathTraverseList.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/path/RTPathTraverseList.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/rand/randadv.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/rand/randadv.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/rand/randadv.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2008-2011 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/rand/randparkmiller.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/rand/randparkmiller.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/rand/randparkmiller.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2008-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/string/RTStrNLen.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/RTStrNLen.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/string/RTStrNLen.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2008-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/string/RTStrNLenEx.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/RTStrNLenEx.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/string/RTStrNLenEx.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2008-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/string/RTStrPrintHexBytes.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/RTStrPrintHexBytes.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/string/RTStrPrintHexBytes.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/string/base64.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/base64.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/string/base64.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2009-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/string/strcache.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/strcache.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/string/strcache.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/string/strformatnum.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/strformatnum.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/string/strformatnum.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2013 Oracle Corporation
+ * Copyright (C) 2010-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/string/strformattype.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/strformattype.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/string/strformattype.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2008-2011 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/string/strversion.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/strversion.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/string/strversion.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/table/avlogcphys.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/table/avlogcphys.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/table/avlogcphys.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010 knut st. osmundsen (bird-src-spam@anduin.net)
+ * Copyright (C) 2006-2010 knut st. osmundsen (bird-src-spam@anduin.net)
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/vfs/vfsbase.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/vfs/vfsbase.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/vfs/vfsbase.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2010-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/vfs/vfschain.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/vfs/vfschain.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/vfs/vfschain.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012 Oracle Corporation
+ * Copyright (C) 2010-2012 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/vfs/vfsmisc.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/vfs/vfsmisc.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/vfs/vfsmisc.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2010-2011 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/vfs/vfsstdfile.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/vfs/vfsstdfile.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/vfs/vfsstdfile.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2010-2011 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/zip/tarvfs.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/zip/tarvfs.cpp	(revision 44528)
+++ trunk/src/VBox/Runtime/common/zip/tarvfs.cpp	(revision 44529)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2010-2011 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as